function show_elf_made(elf,mip,N)
% SHOW_ELF_MADE  Show equations for an ELF MADE structure
%
%   SHOW_ELF_MADE(ELF,MIP,N)
%
%   Show equations for a MADE structure (using CMPI.SHOW_MILP).
%
%   Inputs
%   ELF     ELF model structure
%   MIP     MIP generated by MADE (through DIFFADJ)
%   N       Number of conditions

[rnames,cnames] = get_elf_names(elf);

rnames{end+1} = 'growth_con';  % growth constraint

orig_rnames = rnames;
orig_cnames = cnames;
rnames = append_all(rnames,1);
cnames = append_all(cnames,1);
for i = 2 : N
    rnames(end+1:end+length(orig_rnames)) = append_all(orig_rnames,i);
    cnames(end+1:end+length(orig_cnames)) = append_all(orig_cnames,i);
end

cmpi.show_mip(mip,[],[],rnames,cnames,true);


function [appended] = append_all(names,number)
    appended = cellfun(@(x) [x '[' num2str(number) ']'], names, ...
                       'Uniform', false);
                   